commit 62e4f0e8977497e01d2c262a3bd459ab26a5aaca
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue Oct 19 09:24:57 2021

    c++: Don't reject calls through PMF during constant evaluation [PR102786]
    
    The following testcase incorrectly rejects the c initializer,
    while in the s.*a case cxx_eval_* sees .__pfn reads etc.,
    in the s.*&S::foo case get_member_function_from_ptrfunc creates
    expressions which use INTEGER_CSTs with type of pointer to METHOD_TYPE.
    And cxx_eval_constant_expression rejects any INTEGER_CSTs with pointer
    type if they aren't 0.
    Either we'd need to make sure we defer such folding till cp_fold but the
    function and pfn_from_ptrmemfunc is used from lots of places, or
    the following patch just tries to reject only non-zero INTEGER_CSTs
    with pointer types if they don't point to METHOD_TYPE in the hope that
    all such INTEGER_CSTs with POINTER_TYPE to METHOD_TYPE are result of
    folding valid pointer-to-member function expressions.
    I don't immediately see how one could create such INTEGER_CSTs otherwise,
    cast of integers to PMF is rejected and would have the PMF RECORD_TYPE
    anyway, etc.
    
    2021-10-19  Jakub Jelinek  <jakub@redhat.com>
    
            PR c++/102786
            * constexpr.c (cxx_eval_constant_expression): Don't reject
            INTEGER_CSTs with type POINTER_TYPE to METHOD_TYPE.
    
            * g++.dg/cpp2a/constexpr-virtual19.C: New test.
    
    (cherry picked from commit f45610a45236e97616726ca042898d6ac46a082e)

diff --git a/gcc/cp/constexpr.c b/gcc/cp/constexpr.c
index 3da7a246167..4f1f454fe1c 100644
--- a/gcc/cp/constexpr.c
+++ b/gcc/cp/constexpr.c
@@ -6101,6 +6101,10 @@ cxx_eval_constant_expression (const constexpr_ctx *ctx, tree t,
 
       if (TREE_CODE (t) == INTEGER_CST
 	  && TYPE_PTR_P (TREE_TYPE (t))
+	  /* INTEGER_CST with pointer-to-method type is only used
+	     for a virtual method in a pointer to member function.
+	     Don't reject those.  */
+	  && TREE_CODE (TREE_TYPE (TREE_TYPE (t))) != METHOD_TYPE
 	  && !integer_zerop (t))
 	{
 	  if (!ctx->quiet)
diff --git a/gcc/testsuite/g++.dg/cpp2a/constexpr-virtual19.C b/gcc/testsuite/g++.dg/cpp2a/constexpr-virtual19.C
new file mode 100644
index 00000000000..cb0d1bed0b1
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp2a/constexpr-virtual19.C
@@ -0,0 +1,11 @@
+// PR c++/102786
+// { dg-do compile { target c++20 } }
+
+struct S {
+  virtual constexpr int foo () const { return 42; }
+};
+
+constexpr S s;
+constexpr auto a = &S::foo;
+constexpr auto b = (s.*a) ();
+constexpr auto c = (s.*&S::foo) ();

